Codeforces 37E-Trial for Chief


Trial for Chief
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Having unraveled the Berland Dictionary, the scientists managed to read the notes of the chroniclers of that time. For example, they learned how the chief of the ancient Berland tribe was chosen.

As soon as enough pretenders was picked, the following test took place among them: the chief of the tribe took a slab divided by horizontal and vertical stripes into identical squares (the slab consisted of N lines and M columns) and painted every square black or white. Then every pretender was given a slab of the same size but painted entirely white. Within a day a pretender could paint any side-linked set of the squares of the slab some color. The set is called linked if for any two squares belonging to the set there is a path belonging the set on which any two neighboring squares share a side. The aim of each pretender is to paint his slab in the exactly the same way as the chief’s slab is painted. The one who paints a slab like that first becomes the new chief.

Scientists found the slab painted by the ancient Berland tribe chief. Help them to determine the minimal amount of days needed to find a new chief if he had to paint his slab in the given way.

Input

The first line contains two integers N and M (1 ≤ N, M ≤ 50) — the number of lines and columns on the slab. The next N lines contain Msymbols each — the final coloration of the slab. W stands for the square that should be painted white and B — for the square that should be painted black.

Output

In the single line output the minimal number of repaintings of side-linked areas needed to get the required coloration of the slab.

Examples
input
Copy
3 3
WBW
BWB
WBW
output
2
input
Copy
2 3
BBB
BWB
output
1

题意:给定一幅n*m的黑白图,现在要求在全白图里进行染色,每次能把一块四联通快染成同一种颜色,问至少需要几次才能和给定图染得一样

解题思路:从目标图开始将图染成初始图,对于直接相邻的两个格子连边,如果颜色相同,则权值为0,反之为1,然后在图上跑最短路,显然对于每个单位距离,我们都要重新染色一次,所以答案即为从某一个点出发最远距离的最小值 + 1(注意:如果终态染成了全黑的图,因为初始图是全白,所以代价 + 1)


#include <iostream>  
#include <cstdio>  
#include <cstring>  
#include <string>  
#include <algorithm>  
#include <map>  
#include <set>
#include <stack>  
#include <queue>  
#include <vector>  
#include <bitset>  
#include <functional>  

using namespace std;

#define LL long long
const int INF = 0x3f3f3f3f;

char ch[60][60];
int n, m, id[60][60], cnt;
int dir[4][2] = { {1, 0}, {-1, 0}, {0, 1}, {0, -1} };
int s[2509], nt[2509 * 5009], e[2509 * 5009], val[2509 * 5009];
int vis[2509], dis[2509];

int SPFA(int k)
{
	memset(dis, INF, sizeof dis);
	queue<int>q;
	q.push(k);
	vis[k] = 1;
	dis[k] = 0;
	while (!q.empty())
	{
		int pre = q.front();
		q.pop();
		vis[pre] = 0;
		for (int i = s[pre]; ~i; i = nt[i])
		{
			if (dis[e[i]] > dis[pre] + val[i])
			{
				dis[e[i]] = dis[pre] + val[i];
				if (!vis[e[i]])
				{
					vis[e[i]] = 1;
					q.push(e[i]);
				}
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
		{
			if (ch[i][j] == 'W') ans = max(ans, dis[id[i][j]]);
			else ans = max(ans, dis[id[i][j]] + 1);
		}
	return ans;
}

int main()
{
	while (~scanf("%d %d", &n, &m))
	{
		memset(s, -1, sizeof s);
		cnt = 0;
		for (int i = 0; i < n; i++) scanf("%s", ch[i]);
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				id[i][j] = i * m + j;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
			{
				for (int k = 0; k < 4; k++)
				{
					int xx = i + dir[k][0];
					int yy = j + dir[k][1];
					if (xx < 0 || xx >= n || yy < 0 || yy >= m) continue;
					if (ch[i][j] == ch[xx][yy])
					{
						nt[cnt] = s[id[i][j]], s[id[i][j]] = cnt, e[cnt] = id[xx][yy], val[cnt++] = 0;
					}
					else
					{
						nt[cnt] = s[id[i][j]], s[id[i][j]] = cnt, e[cnt] = id[xx][yy], val[cnt++] = 1;
					}
				}
			}
		int ans = INF;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				ans = min(ans, SPFA(id[i][j]));
		printf("%d\n", ans);
	}
	return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值